#ifndef _HDVSEND_PARAM_H_
#define _HDVSEND_PARAM_H_

#include <sys/queue.h>
#include <netdb.h>
#include <net/if.h>
#include "ieee1394-struct.h"

#ifdef	LINUX_OLD_SS_FAMILY
#define	ss_family	__ss_family
#endif	/* LINUX_OLD_SS_FAMILY */

#define DEFAULT_DVCR_RTP_PT	123
#define DEFAULT_MPEG_RTP_PT      33

#define DVRTPFREQ               90000
#define DVNTSCRTPTSINC          3003
#define DVPALRTPTSINC           360

TAILQ_HEAD(dest_list_head, dest_obj); 

struct dest_obj {
  int soc;
  struct sockaddr_storage rtp_s_addr;
  struct sockaddr_storage rtcp_s_addr;

  char  dest_str[NI_MAXHOST];
  char  serv[NI_MAXSERV];

  /* FOR MULTICAST */
  int multi_ttl;
  char multi_if[IF_NAMESIZE];

  u_int32_t	pkt_count;
  u_int32_t	oct_count;

  TAILQ_ENTRY(dest_obj) chain;
};

TAILQ_HEAD(rtcp_recv_list_head, rtcp_recv_obj);

struct rtcp_recv_obj {
  int soc;
  struct sockaddr_storage s_addr;

  TAILQ_ENTRY(rtcp_recv_obj) chain;
};

struct hdvsend_param {
  int format;

  char default_serv[NI_MAXSERV];
  char default_audio_serv[NI_MAXSERV];
  int default_multi_ttl;
  char default_multi_src_addr[18];

  /* IP destination host list */
  struct dest_list_head dest_list;
  struct dest_list_head dest_audio_list;
  
  struct rtcp_recv_list_head rtcp_recv_list;
  struct rtcp_recv_list_head rtcp_recv_audio_list;

  /*--------------------*/
  /* IEEE1394 PARAMTERS */
  /*--------------------*/
  struct ieee1394io ieee1394io;

  /*----------------------*/
  /* DV RELATED PARAMTERS */
  /*----------------------*/
  /* frame drop rate */
  int frame_drop;

  /* DIF blocks in each RTP packet */
  int DIFblocks_in_pkt;

  int mtu;

  int audio_redundancy;

  u_int32_t frame_max;
  int output_fd;

  /*-------------------------------*/
  /*             FLAGS             */
  /* see dvsend-flags.h for detail */
  /*-------------------------------*/
  unsigned long flags;

  int do_sleep_count;
  long int dvrtp_interval; /* nanosec */

  u_int8_t rtp_pt;
  u_int32_t rtp_ssrc;
};

#endif /* _HDVSEND_PARAM_H_ */
