/*
 * Copyright (c) 1999-2003 WIDE Project
 * All rights reserved.
 *
 * Author : Akimichi OGAWA (akimichi@sfc.wide.ad.jp)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code MUST retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form MUST reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    MUST display the following acknowledgement:
 *      This product includes software developed by Akimichi OGAWA.
 * 4. The name of the author MAY NOT be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
*/

#ifndef _HDVSEND_IEEE1394_STRUCT_H_
#define _HDVSEND_IEEE1394_STRUCT_H_

#include <sys/param.h>
#include <ieee1394header.h>

#include <dvts-config.h>

#ifdef LINUX
#include <libraw1394/raw1394.h>
#include <libraw1394/csr.h>
#define DEFAULTIEEE1394DEV "/dev/dv1394"
#define MAXPORT 16
#endif /* LINUX */

#ifdef __FreeBSD__
#if __FreeBSD_version >= 480000
#define DEFAULTIEEE1394DEV "/dev/fw0"
#else /*__FreeBSD_version >= 480000 */
#define DEFAULTIEEE1394DEV "ohci0"
#endif /* __FreeBSD_version >= 480000 */
#endif  /* __FreeBSD__ */

#ifdef  NetBSD
#define DEFAULTIEEE1394DEV "/dev/fwiso0"
#endif  /* NetBSD */

struct ieee1394io {
	int channel;	/* IEEE1394 isochronous channel */
	int fd;	/* for receiving data from IEEE1394 device */
#ifdef LINUX
	raw1394handle_t handle;
	struct raw1394_portinfo portinfo[MAXPORT];
	int cardnum;
#endif /* LINUX */
	u_int16_t prev_cycle_count;
	u_int16_t prev_cycle_offset;
	u_int16_t time_sub;
	char  ifname[MAXPATHLEN + 1];
	struct ieee1394ciphdr ciphdr;
};

#endif /* _HDVSEND_IEEE1394_STRUCT_H_ */
